import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import java.io.FileOutputStream;
import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

public class TransformProd extends Object {

public static void main (String args[]) throws Exception
{
    String XMLFileName = "products.xml";
    String XSLSheetName = "productpage.xsl";
  
    TransformerFactory transFactory = TransformerFactory.newInstance();
    Transformer transformer = 
               transFactory.newTransformer(new StreamSource(XSLSheetName));

    DOMParser parser = new DOMParser();
    parser.parse(XMLFileName);
    Document document = parser.getDocument();

    NodeList products =
             document.getElementsByTagName("product_id");
    int num_products = products.getLength();

    System.out.println("There are "+num_products+" products.  They are:");

    String product_id;
    String prev_id;
    String next_id;

    for (int i = 0; i < num_products; i++) {
      product_id = products.item(i)
                           .getChildNodes().item(0).getNodeValue();
      System.out.println(product_id);

      if (i != 0) {
          prev_id = products.item(i-1)
                            .getChildNodes().item(0).getNodeValue();
      } else {
          prev_id = products.item(num_products-1)
                            .getChildNodes().item(0).getNodeValue();
      }
 
      if (i != (num_products-1)) {
          next_id = 
             products.item(i+1).getChildNodes().item(0).getNodeValue();
      } else {
          next_id = 
             products.item(0).getChildNodes().item(0).getNodeValue();
      }

      String outputURL = product_id+".html";
      transformer.setParameter("vProduct_id", product_id);
      transformer.setParameter("vPrev_id", prev_id);
      transformer.setParameter("vNext_id", next_id);

      transformer.transform(new StreamSource(XMLFileName), 
                        new StreamResult(new FileOutputStream(outputURL)));

    }

   }

}

