<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:prod="http://www.nicholaschase.com/products/"
        xmlns:ord="http://www.nicholaschase.com/orders/">
<xsl:template match="/">
    <tempDoc>
        <xsl:apply-templates />
    </tempDoc>
</xsl:template>

<xsl:template match="text()">
    <xsl:apply-templates />
</xsl:template>

<xsl:template match="ord:item">
    <xsl:element name="ord:item">
        <xsl:element name="ord:product_id">
            <xsl:value-of select="@ord:product_id" />
        </xsl:element>
        <xsl:copy-of select="ord:quantity" />
        <xsl:call-template name="vendor_name">
            <xsl:with-param name="vProduct_id">
                <xsl:value-of select="@ord:product_id" />
            </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="short_desc">
            <xsl:with-param name="vProduct_id">
                <xsl:value-of select="@ord:product_id" />
            </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="price">
            <xsl:with-param name="vProduct_id">
                <xsl:value-of select="@ord:product_id" />
            </xsl:with-param>
        </xsl:call-template>
    </xsl:element>
</xsl:template>

<xsl:template name="vendor_name">
    <xsl:param name="vProduct_id"></xsl:param>
    <xsl:copy-of select="//prod:vendor[self::node()//prod:product_id=$vProduct_id]/prod:vendor_name" />
</xsl:template>

<xsl:template name="short_desc">
    <xsl:param name="vProduct_id"></xsl:param>
    <xsl:copy-of select="//prod:short_desc[preceding-sibling::prod:product_id=$vProduct_id]" />
</xsl:template>

<xsl:template name="price">
    <xsl:param name="vProduct_id"></xsl:param>
    <xsl:copy-of select="//prod:price[preceding-sibling::prod:product_id=$vProduct_id and attribute::prod:pricetype='retail']" />
</xsl:template>

</xsl:stylesheet>

