<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
        xmlns:prod="http://www.nicholaschase.com/products/"
        xmlns:ord="http://www.nicholaschase.com/orders/">

<xsl:include href="topinclude.xsl"/>

<xsl:template match="tempDoc">
    <form action="CompleteOrder" method="get">
   <h2>Confirm Order</h2>
    <table>
        <tr>
            <th>Product ID</th>
            <th>Manufacturer</th>
            <th>Description</th>
            <th>Price</th>
            <th>Quantity</th>
            <th>Total Cost</th>
        </tr>
        <xsl:apply-templates select="item" />
        <tr>
            <td align="right" colspan="5">
                Total:
            </td>
            <td>
                <xsl:value-of select="totalCost" />
            </td>
        </tr>
   </table>
  <h3>Payment Information</h3>
    <table>
        <tr>
            <td>Name on Credit Card</td>
            <td><input name="nameOnCard" type="text" /></td>
        </tr>
        <tr>
            <td>Card Type</td>
            <td><select name="cardType">
                <option value="visa">Visa</option>
                <option value="mc">MasterCard</option>
                <option value="amex">American Express</option>
                </select>
            </td>
        </tr>
        <tr>
            <td>Card Number</td>
            <td><input name="cardNumber" type="text" /></td>
        </tr>
        <tr>
            <td>Expiration Date</td>
            <td><input name="expDate" type="text" /></td>
        </tr>
     </table>

    <input type="submit" value="Confirm Order" />
    </form>


</xsl:template>

<xsl:template match="//item">
    <tr>
        <td><xsl:value-of select="product_id"/></td>
        <td><xsl:value-of select="prod:vendor_name"/></td>
        <td><xsl:value-of select="prod:short_desc"/></td>
        <td><xsl:value-of select="prod:price"/></td>
        <td><xsl:value-of select="ord:quantity"/></td>
        <td><xsl:value-of select="itemCost"/></td>
    </tr>
</xsl:template>

</xsl:stylesheet>

