<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:template match="/">
   <xsl:for-each select="//vendor" >
        <xsl:sort select="vendor_name" />
     <xsl:choose>
        <xsl:when test="@webvendor!='no'">
          <xsl:element name="A">
             <xsl:attribute name="href">
                 #<xsl:value-of select="vendor_name"/>
             </xsl:attribute>
              <H2><xsl:value-of select="vendor_name"/></H2>
           </xsl:element>
        </xsl:when>
        <xsl:otherwise>
            <H2><xsl:value-of select="vendor_name"/>*</H2>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>

    <SUP>*</SUP>Products available only in showrooms.


    <hr/>

    <xsl:for-each select="//vendor">
        <xsl:sort select="vendor_name" />
        <xsl:if test="@webvendor!='no'">
             <xsl:apply-templates/>
        </xsl:if>
    </xsl:for-each>

</xsl:template>

<xsl:template match="*">
      <xsl:apply-templates/>
</xsl:template>

<xsl:template match="text()">
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="product">
  <xsl:choose>
 <xsl:when test="parent::node()[@webvendor='full']">
    <UL><LI>
          <xsl:apply-templates select="product_id"/>
        <xsl:value-of select="short_desc"/>
        <BR/><xsl:apply-templates select="inventory[@color]"/>
        <P><xsl:value-of
                select=".//price[@pricetype='sale'] |
                        .//price[@pricetype='retail']"/></P>
    </LI></UL>
  </xsl:when>
  <xsl:when test="parent::node()[@webvendor='partial']">
          <xsl:value-of select="short_desc"/><BR/>
  </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template match="product/product_id">
    <xsl:value-of select="."/>:
</xsl:template>

<xsl:template match="inventory[@color  and @location='warehouse']">
    -- <xsl:value-of select="@color"/><br/>
</xsl:template>

<xsl:template match="vendor_name">
<xsl:element name="a">
  <xsl:attribute name="name"><xsl:value-of select="."/></xsl:attribute>
  <p><xsl:value-of select="."/></p>
</xsl:element>

</xsl:template>
</xsl:stylesheet>

