import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.xerces.parsers.*;
import org.w3c.dom.*;
import org.apache.xerces.dom .*;
import de.gmd.ipsi.xql.*;
import org.apache.xml.serialize.*;

public class CreateIndex extends HttpServlet {

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
            throws IOException, ServletException
    {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    try {
        DOMParser parser = new DOMParser();
        parser.parse("/files/products.xml");
        Document products = parser.getDocument();

        Document index = new DocumentImpl();
        Element indexRoot = index.createElement("index");

        XQLResult descNodes =
            XQL.execute("//short_desc | //long_desc", products);
        for (int i=0; i < descNodes.getLength(); i++) {

            Element entry = index.createElement("entry");
            Node thisDesc = (Node)descNodes.getItem(i);
            String thisDescStr =
                thisDesc.getFirstChild().getNodeValue();

            Element thisProduct =
                (Element)thisDesc.getParentNode();
            Node thisProduct_id =
                thisProduct.getElementsByTagName("product_id").item(0);
            String thisProduct_idStr =
                thisProduct_id.getFirstChild().getNodeValue();

            Element product_id = index.createElement("product_id");
            Node product_idTxt =
                index.createTextNode(thisProduct_idStr);
            product_id.appendChild(product_idTxt);
            entry.appendChild(product_id);

            StringTokenizer keywords =
                new StringTokenizer(thisDescStr, " ");

            while (keywords.hasMoreTokens()) {
                String keywordStr = keywords.nextToken();
                Element keyword = index.createElement("keyword");
                Node keywordTxt = index.createTextNode(keywordStr);
                keyword.appendChild(keywordTxt);
                entry.appendChild(keyword);
            }
        
            indexRoot.appendChild(entry);

        }

        index.appendChild(indexRoot);

        OutputFormat format = new OutputFormat(index, "UTF-8", true);
        FileWriter indexFile = new FileWriter("/files/index.xml");

        XMLSerializer output = new XMLSerializer(out, format);
        output.serialize(index);
        indexFile.flush();
        indexFile.close();

        out.print("Done.");

     } catch (org.xml.sax.SAXException SAXe) {
        out.print("There was a problem with the source"
            + " document:" + SAXe.getMessage());
    }
  }
}
