import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import org.apache.xml.serialize.*;
import org.apache.xerces.parsers.*;
import de.gmd.ipsi.xql.*;

public class SearchResults extends HttpServlet {

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
             throws IOException, ServletException
  {
  response.setContentType("text/html");
  PrintWriter out = response.getWriter();

    try {

          Document page = new DocumentImpl();

          TransformerFactory transFactory = 
               TransformerFactory.newInstance();
          Transformer transformer = 
               transFactory.newTransformer(
                     new StreamSource("/files/topinclude.xsl"));

          DOMResult result = new DOMResult();

          transformer.transform(new DOMSource(page), 
                                result);

          page = (Document)result.getNode();

          Node body = page.getElementsByTagName("body").item(0);

          String key = request.getParameter("key");
          Node bodyText =
              page.createTextNode("Results for keyword: "+key);
          body.appendChild(bodyText);
          body.appendChild(page.createElement("p"));

          DOMParser parser = new DOMParser();
          parser.parse("/files/index.xml");
          Document index = parser.getDocument();
 
          XQLResult results =
            XQL.execute("//entry[keyword $contains$ '"+key+"']/product_id",
                                                         index);
         if (results.getLength() > 0) {

             body.appendChild(page.createTextNode("Products:  "));
             body.appendChild(page.createElement("br"));

             parser.parse("/files/products.xml");
             Document products = parser.getDocument();

             for (int i=0; I < results.getLength(); i++) {
                 Node product_id = (Node)results.getItem(i);
                 String product_idStr =
                     product_id.getFirstChild().getNodeValue();
                 XQLResult product =
                     XQL.execute("//product[product_id='"+product_idStr+"']/short_desc",
                                      products);
                 Node nameNode = (Node)product.getItem(0);
                 String name = nameNode.getFirstChild().getNodeValue();

                 Element prodLink = page.createElement("a");
                 prodLink.setAttribute("href",
                       "TransformServlet?product_id="+product_idStr);
                 prodLink.appendChild(page.createTextNode(name));

                 body.appendChild(prodLink);
                 body.appendChild(page.createElement("br"));
             }

      } else {

          body.appendChild(
                     page.createTextNode("No products found."));

      }

          OutputFormat format = new OutputFormat(page, "UTF-8", true);
          XMLSerializer output = new XMLSerializer(out, format);
          output.serialize(page);

    } catch (Exception e) {
          out.print("There was a problem with the source"
              + " document:" + e.getMessage());
    }

  }


  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
             throws IOException, ServletException
  {
      doGet(request, response);
  }
}
