import java.sql.*;
import org.apache.xerces.parsers.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;

public class CreateInventory {

    static Connection furnDB = null;
    static Statement sql = null;
    static String sqlTxt = "";

    public static void insertInventory(String product_id,
                                       String color,
                                       String location,
                                       String inv) throws SQLException
    {

        if (color.equals("")) {
            color = "none";
        }

        sqlTxt = "insert into inventory " +
                        "(product_id, color, location, inv) values " +
                        "('"+product_id+"',  '"+color+"', " +
                        " '"+location+"', "+inv+")";
        System.out.println(sqlTxt);

        sql = furnDB.createStatement();
        sql.execute(sqlTxt);

    }

    public static void main(String[] args) {

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (ClassNotFoundException e) {
            System.out.println("There was a problem loading " +
               "the database driver.");
            return;
        }

        try {
            String URL = "jdbc:odbc:furniture";
            String username = "";
            String password = "";

            furnDB = DriverManager.getConnection (URL,
                                                  username,
                                                  password);
            sql = furnDB.createStatement();

        } catch (SQLException e) {
            System.out.println("There was a problem connecting to " +
               "the database.");
            return;
        }

        try {
            DOMParser parser = new DOMParser();
            parser.parse("/files/products.xml");
            Document productDoc = parser.getDocument();

            Element productRoot = productDoc.getDocumentElement();
            NodeList products =
                   productRoot.getElementsByTagName("product");
            for (int i=0; i < products.getLength(); i++) {
                Element thisProduct = (Element)products.item(i);
                Element thisProduct_id = (Element)thisProduct
                       .getElementsByTagName("product_id").item(0);
                String product_id =
                       thisProduct_id.getFirstChild().getNodeValue();
                System.out.print("\nInventory for product "+
                       product_id+"\n");

                NodeList inventoryElements =
                       thisProduct.getElementsByTagName("inventory");
                for (int j=0; j < inventoryElements.getLength(); j++) {
                    Element thisInventory =
                          (Element)inventoryElements.item(j);
                    String thisColor =
                          thisInventory.getAttribute("color");
                    System.out.print("color="+thisColor+" | ");

                    String thisLocation =
                          thisInventory.getAttribute("location");
                    System.out.print("location="+thisLocation+" | ");

                    String thisInv =
                          thisInventory.getFirstChild().getNodeValue();
                    insertInventory(product_id, thisColor,
                                            thisLocation, thisInv);
                }
            }

        } catch (java.io.IOException e) {
            System.out.print("There was a problem reading products.xml.");
        } catch (SQLException e) {
            System.out.print("There was a problem with the SQL string: "+
                                                                  sqlTxt);
        } catch (org.xml.sax.SAXException e) {
            System.out.print("There was a problem parsing products.xml.");
        }

        try {
            furnDB.close();
        } catch (SQLException e) {
            System.out.print("Couldn't close database.");
        }
    }

}
