import org.xml.sax.helpers.*;
import org.xml.sax.*;
import java.sql.*;

public class ParseOrders extends DefaultHandler {

    public ParseOrders() {
        //Not really doing anything...
        System.out.println("This is the constructor.");
    }

    String currentElement = "";
    String currentProduct_id = "";
    String currentColor = "";
    Hashtable products = new Hashtable();
    String currentKey = "";

    public void startElement(java.lang.String uri,
                         java.lang.String localName,
                         java.lang.String qName,
                         Attributes attributes)
                  throws SAXException
    {

        currentElement = localName;
        if (currentElement.equals("item")) {
            currentProduct_id = attributes.getValue(0);
            if (attributes.getLength() > 1) {
                currentColor = attributes.getValue(1);
            } else {
                currentColor = "none";
            }
            currentKey = currentProduct_id + "|" + currentColor;
        }

    }

    public void endElement(java.lang.String uri,
                         java.lang.String localName,
                         java.lang.String qName)
                  throws SAXException  {

        currentElement = "";

    }

    public void characters(char[] ch,
                       int start,
                       int length)
                throws SAXException  {

        if (currentElement.equals("quantity")) {

            String allchar = new String(ch, start, length);

            if (products.containsKey(currentKey)) {

                String currentValue =
                       (String)products.get(currentKey);
                int current = new Integer(currentValue).intValue();
                int newint = new Integer(allchar).intValue();
                int subtotal = current + newint;
                products.put(currentKey,
                             currentKey.valueOf(subtotal) );

            } else {
                products.put(currentKey, allchar);
            }
        }

    }

    public void showTotals () {

        Enumeration allProducts = products.keys();
        while (allProducts.hasMoreElements()) {
            String thisKey = (String)allProducts.nextElement();
            String thisValue = (String)products.get(thisKey);
            System.out.print(thisKey+": "+thisValue+"\n");
        }

    }

     Connection furnDB = null;
     Statement sql = null;

     public void update(String thisProduct_id,
                       String thisColor,
                       String thisValue) throws SQLException {

         String sqlTxt = "update inventory set inv = (inv - " +
               thisValue +") where product_id = '"+thisProduct_id+"' "+
               " and color = '"+ thisColor+"'"+
               " and location = 'warehouse'";

         System.out.println(sqlTxt);

         int numFound = sql.executeUpdate(sqlTxt);

         if ( numFound == 0 ) {
             sqlTxt =  "update inventory set inv = (inv - " +
               thisValue +") where product_id = '"+thisProduct_id+"' "+
               " and color = '"+ thisColor+"' " +
               " and location = 'showroom'";
             System.out.println(sqlTxt);
             numFound = sql.executeUpdate(sqlTxt);
         }

         if ( numFound == 0 ) {
             sqlTxt = "insert into inventory " +
                "(product_id, color, location, inv) values "+
                "('"+thisProduct_id+"', '"+thisColor+"', " +
                "'showroom', -"+thisValue+")";
             System.out.println(sqlTxt);
             sql.execute(sqlTxt);
         }

     }

     public void saveTotals() {
         String URL = "jdbc:odbc:furniture";
         String username = "";
         String password = "";

         try {
             Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
         } catch (ClassNotFoundException e) {
             System.out.println("Problem loading the database driver.");
             return;
         }

         try {
             furnDB = DriverManager.getConnection (URL,
                                                   username,
                                                   password);
            sql = furnDB.createStatement();

            Enumeration allProducts = products.keys();
            while (allProducts.hasMoreElements()) {
                String thisKey = (String)allProducts.nextElement();

                StringTokenizer tokenizer =
                         new StringTokenizer(thisKey, "|");
                String thisProduct = tokenizer.nextToken();
                String thisColor = tokenizer.nextToken();

                String thisValue = (String)products.get(thisKey);

                 update(thisProduct, thisColor, thisValue);

            }

            furnDB.close();
        } catch (Exception e) {
            System.out.println("Problem updating the database.");
            return;
        }

    }

     public void showBackorders() {

         String sqlTxt = "select product_id, color, sum(inv) from "+
                  "inventory group by product_id, color " +
                  "having sum(inv) < 0";
         try {
             ResultSet backorders = sql.executeQuery(sqlTxt);

             while (backorders.next()){
                 System.out.println(backorders.getString(1)+", " +
                                    backorders.getString(2)+", " +
                                    backorders.getString(3));
             }

             furnDB.close();

         } catch (SQLException e) {
             System.out.println("Could not select from database.");
             return;
         }

     }

    public static void main(String[] args) {

        ParseOrders update = new ParseOrders();
        try {
            XMLReader parser = XMLReaderFactory
               .createXMLReader("org.apache.xerces.parsers.SAXParser");

            parser.setContentHandler(update);
            parser.parse("/files/ordersUpdate.xml");

        } catch (Exception e) {
            System.out.println("There was a problem parsing the file.");
            return;
        }
        update.saveTotals();
        update.showBackorders();

    }

}
