import java.io.*;
import org.apache.xerces.parsers.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.apache.xml.serialize.*;

public class UpdateInventory extends Object {

     public static void main (String[] args) {

        String origOrders = "/files/orders.xml";
        String newOrders = "/files/ordersUpdate.xml";

        File ordersFile = new File(origOrders);
        File oldUpdateFile = new File(newOrders);
        oldUpdateFile.delete();

        File newOrdersFile = new File(newOrders);
        ordersFile.renameTo(newOrdersFile);

        DOMParser parser = new DOMParser();
        try {
            parser.parse("/files/ordersUpdate.xml");
        } catch (Exception e) {
            System.out.println("Could not parse ordersUpdate.xml.");
            return;
        }

        Document orderDoc = parser.getDocument();
        Element orderRoot = orderDoc.getDocumentElement();
        NodeList orders = orderRoot.getElementsByTagName("order");
        for (int i=0; i < orders.getLength(); i++) {

            Element thisOrder = (Element)orders.item(i);
            Node thisStatus = thisOrder
                  .getElementsByTagName("order_status").item(0);
            String thisStatusStr =
                      thisStatus.getFirstChild().getNodeValue();
            if (!thisStatusStr.equals("open")) {
                 orderRoot.removeChild(thisOrder);
            }
        }

        try {
            OutputFormat format =
                             new OutputFormat(orderDoc, "UTF-8", true);
            XMLSerializer output =
                  new XMLSerializer(new FileWriter("/files/orders.xml"),
                                    format);
            output.serialize(orderDoc);
        } catch (IOException e) {
            System.out.print("Couldn't replace orders.xml.");
        }

    }

}
