import java.util.*;
import java.io.*;
import org.apache.xerces.parsers.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.apache.xml.serialize.*;
import java.sql.*;

public class UpdateProduct extends Object {

    public static void main(String[] args) {

        String URL = "jdbc:odbc:furniture";
        String username = "";
        String password = "";

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (Exception e) {
            System.out.println("Problem loading database driver.");
            return;
        }

        Connection furnDB = null;
        Statement sql = null;
        try {
            furnDB = DriverManager.getConnection ( URL,
                                                   username,
                                                   password);
            sql = furnDB.createStatement();
        } catch (SQLException SQLe) {
            System.out.println("Could not open database.");
            return;
        }

        try {
            DOMParser parser = new DOMParser();
            parser.parse("/files/products.xml");
            Document productDoc = parser.getDocument();

            Element productRoot = productDoc.getDocumentElement();
            NodeList products =
                  productRoot.getElementsByTagName("product");
            for (int i=0; i < products.getLength(); i++) {
                Element thisProduct = (Element)products.item(i);

                Node thisProduct_id = thisProduct
                         .getElementsByTagName("product_id")
                         .item(0);
                String product_id =
                      thisProduct_id.getFirstChild().getNodeValue();

                NodeList inventoryElements =
                      thisProduct.getElementsByTagName("inventory");
                for (int j=0; j < inventoryElements.getLength(); j++) {
                    Element thisInventory =
                           (Element)inventoryElements.item(j);
                    String thisColor =
                           thisInventory.getAttribute("color");
                    if (thisColor.equals("")) {
                        thisColor = "none";
                    }

                    String thisLocation =
                           thisInventory.getAttribute("location");

                    String sqlTxt = "select inv from inventory " +
                        "where product_id = '"+product_id+"' and "+
                        "color = '"+thisColor+"' and "+
                        "location = '"+thisLocation+"'";

                    ResultSet results = null;
                    try {

                        results = sql.executeQuery(sqlTxt);

                    } catch (SQLException e) {
                        System.out.println("Problem selecting data.");
                    }
                    if (results.next()) {
                        System.out.println("Found "+product_id +
                              ", "+thisColor+", "+thisLocation);
                        String thisValue = results.getString(1);
                        Node newInv =
                              productDoc.createTextNode(thisValue);
                        thisInventory.replaceChild(newInv,
                                    thisInventory.getFirstChild());
                    } else {
                        System.out.println("Didn't find :"+product_id +
                              ", "+thisColor+", "+thisLocation);
                        Node newInv = productDoc.createTextNode("0");
                        thisInventory.replaceChild(newInv,
                                    thisInventory.getFirstChild());
                    }
                }
            }

            try {
                furnDB.close();
            } catch (SQLException e) {
                System.out.println("Could not close database.");
            }

            OutputFormat format =
                 new OutputFormat(productDoc, "UTF-8", true);
            XMLSerializer output =
                 new XMLSerializer(new FileWriter("/files/products.xml"),
                 format);
            output.serialize(productDoc);

        } catch (Exception e) {
            System.out.print("Problem updating document.");
        }

    }

}
