import java.util.*;
import javax.servlet.http.*;
import java.io.*;
import org.apache.xerces.dom.*;
import org.apache.xerces.parsers.*;
import org.w3c.dom.*;
import org.apache.xml.serialize.*;
import org.xml.sax.*;

public class SOAPServlet extends HttpServlet
{
    public void doPost(HttpServletRequest request,
                       HttpServletResponse response)
                              throws IOException
    {

        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        String SOAPMethodName = 
                       request.getHeader("SOAPMethodName");

        StringTokenizer SOAPHeader = 
                 new StringTokenizer(SOAPMethodName, "#");
        String ns = SOAPHeader.nextToken();
        String className = SOAPHeader.nextToken();
        out.print("The namespace is "+ns+"<br />");
        out.print("The className is "+className+"<br />");

        Hashtable payload = new Hashtable();
        try {

            DOMParser parser = new DOMParser();
            parser.parse(
                  new InputSource(request.getInputStream()));
            Document envelope = parser.getDocument();
            Element body = 
                  (Element)envelope.getElementsByTagName("body").item(0);
            Node payloadEl = 
                  body.getElementsByTagName(className).item(0);
            NodeList childElements = payloadEl.getChildNodes();
            for (int i=0; i < childElements.getLength(); i++) {
                payload.put(childElements.item(i).getLocalName(),
                       childElements.item(i).getFirstChild().getNodeValue());
            }           

        } catch (Exception e) { 
            out.print("Problem parsing payload: "+e.getMessage()); 
        }

        Hashtable result = null;
        try {

            Class calledClass = Class.forName("SOAPProcess");
            Class[] parameterTypes = new Class[] {Hashtable.class};
            java.lang.reflect.Method SOAPMethod;
            Object[] arguments = new Object[] {payload};

            SOAPMethod = 
                 calledClass.getMethod(methodName, parameterTypes);
            result = (Hashtable) SOAPMethod.invoke(null, arguments);
            out.print(result.toString());
     
        } catch (Exception e) { 
            out.print("Problem calling the work servlet: "
                                              +e.getMessage());
        }

        Document SOAPRes = new DocumentImpl();
        Element envelope = SOAPRes.createElement("envelope");
        Element body = SOAPRes.createElement("body");
        Element returnResult = SOAPRes.createElementNS(
                              ns, methodName+"Result");

        Enumeration allKeys = result.keys();
        while (allKeys.hasMoreElements()) {
            String thisKey = (String)allKeys.nextElement();
            String thisValue = (String)result.get(thisKey);
            Element thisElement = 
                 SOAPRes.createElement(thisKey);
            thisElement.
                 appendChild(SOAPRes.createTextNode(thisValue));
            returnResult.appendChild(thisElement);
        }
        body.appendChild(returnResult);
        envelope.appendChild(body);
        SOAPRes.appendChild(envelope);

        OutputFormat format = 
             new OutputFormat(SOAPRes, "UTF-8", false);
        XMLSerializer output = new XMLSerializer(out, format);
        output.serialize(SOAPRes);
    }

}
