import javax.servlet.http.*;
import java.net.*;
import java.io.*;
import org.apache.xerces.dom.*;
import org.apache.xerces.parsers.*;
import org.w3c.dom.*;
import org.apache.xml.serialize.*;

public class SendServlet extends HttpServlet
{
    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
                             throws IOException
    {
        
        Document SOAPReq = new DocumentImpl();
        Element envelope = SOAPReq.createElement("envelope");
        Element body = SOAPReq.createElement("body");
        Element InventorySold = SOAPReq.createElementNS(
                              "http://www.nicholaschase.com/soap/", 
                              "InventorySold");
        Element product_id = SOAPReq.createElement("product_id");
        Element quantity = SOAPReq.createElement("quantity");

        quantity.appendChild(SOAPReq.createTextNode("1"));
        product_id.appendChild(SOAPReq.createTextNode("QA3452"));
        InventorySold.appendChild(product_id);
        InventorySold.appendChild(quantity);
        body.appendChild(InventorySold);
        envelope.appendChild(body);
        SOAPReq.appendChild(envelope);

        URL url = 
          new URL("http://localhost:8080/book/servlet/SOAPServlet");
        HttpURLConnection conn = 
              (HttpURLConnection)url.openConnection();

        conn.setRequestProperty("SOAPMethodName", 
             "http://www.nicholaschase.com/soap/#InventorySold");

        conn.setRequestMethod("POST");
        conn.setDoOutput(true);
        conn.connect();

        OutputStream toSOAP = conn.getOutputStream();

        OutputFormat format = 
             new OutputFormat(SOAPReq, "UTF-8", false);
        XMLSerializer output = new XMLSerializer(toSOAP, format);
        output.serialize(SOAPReq);

        toSOAP.close();

        InputStream fromSOAP = conn.getInputStream();
        byte[] SOAPResult = new byte[5000];
        int resultLength = fromSOAP.read(SOAPResult);
        String SOAPResultStr = 
                new String(SOAPResult, 0, resultLength);
        fromSOAP.close();

:        response.setContentType("text/html");
:        PrintWriter out = response.getWriter();
:        out.print("The results are: <br />");
         out.print(SOAPResultStr);
        Hashtable SOAPRes = new Hashtable();
        try {

            DOMParser parser = new DOMParser();
            parser.parse(
                  new InputSource(conn.getInputStream()));
            Document envelopeDoc = parser.getDocument();
            body = 
                  (Element)envelopeDoc
                  .getElementsByTagName("body").item(0);
            Node payloadEl = body
                      .getElementsByTagName("InventorySoldResult")
                      .item(0);
            NodeList childElements = payloadEl.getChildNodes();
            for (int i=0; i < childElements.getLength(); i++) {
                SOAPRes.put(childElements.item(i).getLocalName(),
                       childElements.item(i)
                       .getFirstChild().getNodeValue());
            }           

        } catch (Exception e) { 
            out.print("Problem parsing SOAPRes: "+e.getMessage()); 
        }

        out.print("After this order of "+SOAPRes.get("quantity"));
        String reorder = (String)SOAPRes.get("reorder");
        if (reorder.equals("false")) {
            out.print(" we do not need to reorder.");
        } else {
            out.print(" we need to reorder.");
        }

    }

}
