<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<wml>
    <card title="ChaseWeb Vendors">
        <p>
            ChaseWeb Furniture vendors:
        </p>
        <p mode="nowrap">
            <select>
                <xsl:apply-templates match="vendor"/>
            </select>
        </p>
    </card>

    <xsl:for-each select="//vendor">
       <xsl:call-template name="vendorcard" />
    </xsl:for-each>

</wml>
</xsl:template>

<xsl:template match="//vendor">
    <xsl:element name="option">
        <xsl:attribute name="onpick">#<xsl:value-of 
               select="@vendor_id"/></xsl:attribute>
        <xsl:value-of select="vendor_name"/>
    </xsl:element>
</xsl:template>

<xsl:template name="vendorcard">
    <xsl:element name="card">
        <xsl:attribute name="id">
            <xsl:value-of select="@vendor_id" />
        </xsl:attribute>
        <xsl:attribute name="title">
           <xsl:value-of select="vendor_name" />
        </xsl:attribute>
        <p>
            <xsl:value-of select="vendor_name" />
        </p>
        <p mode="nowrap">
            <select>
                <xsl:for-each select="product">
                    <xsl:call-template name="productchoices" />  
                </xsl:for-each>
            </select>
        </p>
    </xsl:element>
</xsl:template>

<xsl:template name="productchoices">
    <xsl:element name="option">
        <xsl:attribute name="onpick"
              >TransformServlet?product_id=<xsl:value-of 
              select="product_id"/></xsl:attribute>
        <xsl:value-of select="short_desc" />
    </xsl:element>
</xsl:template>

</xsl:stylesheet>
