<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:include href="topinclude.xsl"/>

<xsl:param name="vProduct_id"></xsl:param>
<xsl:param name="vPrev_id"> </xsl:param>
<xsl:param name="vNext_id"> </xsl:param>

<xsl:template match="vendor[product/product_id=$vProduct_id]| vendor[suite/product_id=$vProduct_id  ]">
    <h1 align="center">
        <xsl:value-of select="vendor_name"/>
    </h1>
    <xsl:value-of select="advertisement"/>
    <hr />
    <xsl:apply-templates select="product|suite"/>
</xsl:template>

<xsl:template match="//product">

    <xsl:if test="product_id=$vProduct_id">
        Product Number: <xsl:value-of select="product_id"/><br />
        <p><xsl:value-of select="short_desc"/></p>
        <p>Price <xsl:value-of select="price"/></p>
        <xsl:if test="inventory[@location='warehouse' and @color]">
            Available in these great colors:
            <ul>
            <xsl:for-each
                select="inventory[@location='warehouse' and @color]">
                <li><xsl:value-of select="@color"/></li>
            </xsl:for-each>
            </ul>
        </xsl:if>

        <xsl:if test="inventory[@location='showroom']">
            <p>Also available in our stores!</p>
        </xsl:if>
        <hr />
 Add this to my order!<br />
  <form method="post" action="AddToOrder">
     <xsl:element name="input">
       <xsl:attribute name="value"><xsl:value-of select="product_id"/></xsl:attribute>
       <xsl:attribute name="type">hidden</xsl:attribute>
       <xsl:attribute name="name">addProduct_id</xsl:attribute>
     </xsl:element>
     Quantity:  <input type="text" name="addQuantity" value="1" size="3" />
     <input type="submit" value="Add to Order" />
  </form>
        <hr />
        <xsl:element name="a">
            <xsl:attribute name="href">/book/servlet/TransformServlet?product_id=<xsl:value-of select="$vPrev_id"/></xsl:attribute>Previous Product
        </xsl:element>
        <br />
        <xsl:element name="a">
            <xsl:attribute name="href">/book/servlet/TransformServlet?product_id=<xsl:value-of select="$vNext_id"/></xsl:attribute>Next Product
        </xsl:element>
    </xsl:if>
</xsl:template>

<xsl:template match="suite">

    <xsl:if test="product_id=$vProduct_id">
        Product Number: <xsl:value-of select="product_id"/><br />
        <p><xsl:value-of select="short_desc"/></p>
        <p>Price<xsl:value-of select="price"/></p>
        <xsl:if test="inventory[@location='warehouse' and @color]">
            Available in these great colors:<br />
            <ul>
            <xsl:for-each
                select="inventory[@location='warehouse' and @color]">
                <li><xsl:value-of select="@color"/></li>
            </xsl:for-each>
            </ul>
        </xsl:if>

        See also these products:<br />
        <xsl:for-each select="./product">
        <xsl:element name="a">
            <xsl:attribute name="href">/book/servlet/TransformServlet?product_id=<xsl:value-of select="product_id"/></xsl:attribute><xsl:value-of select="product_id"/>
        </xsl:element>
            <br />
        </xsl:for-each>
        <br />
        <xsl:if test="inventory[@location='showroom']">
            <p>Also available in our stores!</p>
        </xsl:if>
        <hr />
  Add this to my order!<br />
  <form method="post" action="AddToOrder">
     <xsl:element name="input">
       <xsl:attribute name="value"><xsl:value-of select="product_id"/></xsl:attribute>
       <xsl:attribute name="type">hidden</xsl:attribute>
       <xsl:attribute name="name">addProduct_id</xsl:attribute>
     </xsl:element>
     Quantity:  <input type="text" name="addQuantity" value="1" size="3" />
     <input type="submit" value="Add to Order" />
  </form>
        <hr />
        <xsl:element name="a">
            <xsl:attribute name="href">/book/servlet/TransformServlet?product_id=<xsl:value-of select="$vPrev_id"/></xsl:attribute>Previous Product
        </xsl:element>
        <br />
        <xsl:element name="a">
            <xsl:attribute name="href">/book/servlet/TransformServlet?product_id=<xsl:value-of select="$vNext_id"/></xsl:attribute>Next Product
        </xsl:element>
    </xsl:if>
</xsl:template>

<xsl:template match="vendor">
    <xsl:apply-templates select="product | suite"/>
</xsl:template>

</xsl:stylesheet>

