import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.OutputFormat;

public class CompleteOrder extends HttpServlet {

  //********* BEGIN doGet() ************
  public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
             throws IOException, ServletException
  {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    try {

        HttpSession session = request.getSession(true);
        String session_id = session.getId();

        String nameOnCard = request.getParameter("nameOnCard");
        String cardType = request.getParameter("cardType");
        String cardNumber = request.getParameter("cardNumber");
        String expDate = request.getParameter("expDate");

        DOMParser parser = new DOMParser();
        parser.parse("/files/orders.xml");
        Document orders = parser.getDocument();

        NodeList allOrders = orders.getElementsByTagName("order");
        for (int i=0; i < allOrders.getLength(); i++) {
            Node thisOrder = allOrders.item(i);
            NamedNodeMap attributes = thisOrder.getAttributes();
            Node order_idNode = attributes.item(0);
            String order_id = order_idNode.getNodeValue();
            if (order_id.equals(session_id)) {
                Node payment = orders.createElement("payment");

                Node nameOnCardNode = orders.createElement("nameOnCard");
                Node nameText = orders.createTextNode(nameOnCard);
                nameOnCardNode.appendChild(nameText);
                payment.appendChild(nameOnCardNode);

                Node cardTypeNode = orders.createElement("cardType");
                Node cardTypeText = orders.createTextNode(cardType);
                cardTypeNode.appendChild(cardTypeText);
                payment.appendChild(cardTypeNode);

                Node cardNumberNode = orders.createElement("cardNumber");
                Node cardNumberText = orders.createTextNode(cardNumber);
                cardNumberNode.appendChild(cardNumberText);
                payment.appendChild(cardNumberNode);

                Node expDateNode = orders.createElement("expDate");
                Node expDateText = orders.createTextNode(expDate);
                expDateNode.appendChild(expDateText);
                payment.appendChild(expDateNode);

                thisOrder.appendChild(payment);

                Node status = orders.getElementsByTagName("order_status").item(0);
                status.setNodeValue("complete");
            }
        }

        OutputFormat format = new OutputFormat(orders, "UTF-8", true);
        XMLSerializer output = new XMLSerializer(new FileWriter("/files/orders.xml"), format);

        output.serialize(orders);

        Output.returnResult("Thank you for your order!", out);

    } catch (Exception e) {
        out.print("There has been an error.");
    }

  }
  //********* END doGet() ************

  //********* BEGIN doPost() ************
  public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
             throws IOException, ServletException
  {
        doGet(request, response);
  }
  //********* END doPost() ************
}

