import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.jdom.Element;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.Namespace;
import org.jdom.output.XMLOutputter;
import org.jdom.input.SAXBuilder;
import java.util.List;
import org.jdom.output.DOMOutputter;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

public class Output extends HttpServlet {

  //*******BEGIN returnResult()*********
  public static void returnResult( 
                            String msgTxt,
                            PrintWriter out )
  {
      File resultFile = new File("/files/msgText.xml");
      Document resultDoc = getDocument(resultFile, out);
      Element resultText = resultDoc.getRootElement();
      Element msgHere = resultText.getChild("msgHere");
      msgHere.addContent(msgTxt);
      File includeFile = new File("/files/topinclude.xsl");
      Document includeDoc = getDocument(includeFile, out);
      Element styleSheetRoot = includeDoc.getRootElement();
 
      List templates = styleSheetRoot.getChildren();
      for (int i=0; i < templates.size(); i++) {
          Element thisTemplate = (Element)templates.get(i);
          String thisMatch = thisTemplate.getAttributeValue("match");
          if (thisMatch.equals("/")) {
              Element htmlElement = thisTemplate.getChild("html");
              Element bodyElement = htmlElement.getChild("body");
              Namespace xslns = Namespace.getNamespace("xsl",
                          "http://www.w3.org/1999/XSL/Transform");
              List allContent =
                   bodyElement.getChildren("apply-templates", xslns);
              allContent.set(0, resultText);
              break;
          }
      }

      try {
          org.w3c.dom.Document DOMDoc;
          DOMOutputter DomOut = new DOMOutputter();
          DOMDoc = DomOut.output(includeDoc);

          TransformerFactory transFactory = 
               TransformerFactory.newInstance();
          Transformer transformer = 
               transFactory.newTransformer(new DOMSource(DOMDoc));
          transformer.transform(new DOMSource(DOMDoc), 
                                new StreamResult(out));
      } catch (Exception e) {
          out.print("There was a problem with the transformation. ");
      }
  }
  //*******END returnResult()*********

  //*******BEGIN getDocument() *********
  public static Document getDocument(File sourceFile,
                              PrintWriter errorsOut)
  {
    try {

        SAXBuilder builder = new SAXBuilder();
        Document document = builder.build(sourceFile);
        return document;

    } catch (JDOMException e) {
        errorsOut.print("There was a problem building the document: "
               +e.getMessage()+"<br />"+
               "Returning blank document.");
        return new Document(new Element("blank"));
    }
  }
  //*******END getDocument() *********


}

