import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import org.apache.xml.serialize.*;

public class SearchResults extends HttpServlet {

  public void doGet(HttpServletRequest request,
                  HttpServletResponse response)
            throws IOException, ServletException
  {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();

    try {

          Document page = new DocumentImpl();

          TransformerFactory transFactory = 
               TransformerFactory.newInstance();
          Transformer transformer = 
               transFactory.newTransformer(
                     new StreamSource("/files/topinclude.xsl"));

          DOMResult result = new DOMResult();

          transformer.transform(new DOMSource(page), 
                                result);

          page = (Document)result.getNode();

          Node body = page.getElementsByTagName("body").item(0);

          String key = request.getParameter("key");

          Node bodyText =
              page.createTextNode("Results for keyword: "+key);
          body.appendChild(bodyText);

          OutputFormat format = new OutputFormat(page, "UTF-8", true);
          XMLSerializer output = new XMLSerializer(out, format);
          output.serialize(page);

    } catch (Exception e) {
          out.print("There was a problem with the source"
              + " document:" + e.getMessage());
    }
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
            throws IOException, ServletException
  {
      doGet(request, response);
  }
}

