import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import java.io.FileOutputStream;
import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class TransformServlet extends HttpServlet  {

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
             throws IOException, ServletException
    {
    String thisProduct_id = request.getParameter("product_id");

    String XMLFileName = "file:///C:/files/products.xml";
    String XSLSheetName = "file:///C:/files/productpage.xsl";

    PrintWriter output = response.getWriter();
  
    try {
    TransformerFactory transFactory = TransformerFactory.newInstance();
    Transformer transformer = 
               transFactory.newTransformer(new StreamSource(XSLSheetName));

    DOMParser parser = new DOMParser();
    parser.parse(XMLFileName);
    Document document = parser.getDocument();

    NodeList products =
             document.getElementsByTagName("product_id");
    int num_products = products.getLength();

    String product_id;
    String prev_id;
    String next_id;

    for (int i = 0; i < num_products; i++) {
      product_id = products.item(i)
                           .getChildNodes().item(0).getNodeValue();

      if (thisProduct_id.equals(product_id)) {

          if (i != 0) {
              prev_id = products.item(i-1)
                           .getChildNodes().item(0).getNodeValue();
          } else {
              prev_id = products.item(num_products-1)
                            .getChildNodes().item(0).getNodeValue();
          }
 
          if (i != (num_products-1)) {
              next_id = 
             products.item(i+1).getChildNodes().item(0).getNodeValue();
          } else {
              next_id = 
             products.item(0).getChildNodes().item(0).getNodeValue();
          }

          transformer.setParameter("vProduct_id", product_id);
          transformer.setParameter("vPrev_id", prev_id);
          transformer.setParameter("vNext_id", next_id);

          transformer.transform(new StreamSource(XMLFileName), 
                        new StreamResult(output));
       }

      }
     } catch (Exception e) {
          output.print("Problem transforming the file.");
     }

   }

}

